# There are architecture dependent files generated by Guile, but
# there is no debug information
%global       debug_package %{nil}
%global       mver 2.0

Name:         skribilo
Version:      0.9.5
Release:      1%{?dist}
Summary:      A free document production tool

License:      GPL-3.0-or-later
URL:          https://www.nongnu.org/%{name}
Source0:      https://download.savannah.nongnu.org/releases/%{name}/%{name}-%{version}.tar.gz
Source1:      https://download.savannah.nongnu.org/releases/%{name}/%{name}-%{version}.tar.gz.sig
Source2:      3CE464558A84FDC69DB40CFB090B11993D9AEBB5

BuildRequires:  emacs
BuildRequires:  gettext-devel
BuildRequires:  glibc-devel
BuildRequires:  guile-devel
BuildRequires:  guile-reader-devel
BuildRequires:  ImageMagick-devel
BuildRequires:  lout
BuildRequires:  make
BuildRequires:  texlive
BuildRequires:  texlive-collection-context
# needed for iconv
BuildRequires:  glibc-common
# needed to check signing
BuildRequires:  gnupg2
Requires:       guile
Requires:       lomt-junction-fonts
Requires:       linux-libertine-biolinum-fonts
Requires:       linux-libertine-fonts
Requires:       source-foundry-hack-fonts
Requires:       texlive-lobster2

%description
Skribilo is a free document production tool that takes a structured document 
representation as its input and renders that document in a variety of output
formats: HTML and Info for on-line browsing, and Lout and LaTeX for
high-quality hard copies.

The input document can use Skribilo's markup language to provide information
about the document's structure, which is similar to HTML or LaTeX and does not
require expertise. Alternatively, it can use a simpler, “markup-less” format
that borrows from Emacs' outline mode and from other conventions used in
emails, Usenet and text.

Last but not least, Skribilo can be thought of as a complete document
programming framework for the Scheme programming language that may be used to
automate a variety of document generation tasks. Technically, the Skribilo
language/API is an embedded domain-specific language (EDSL), implemented via
so-called “deep embedding”. Skribilo uses GNU Guile 3.0 or 2.x as the
underlying Scheme implementation.

%package emacs
Summary:  Skribilo Emacs configuration
Requires:        skribilo
Requires:        emacs
BuildArch: noarch

%description emacs
Configuration files for writing Skribilo documents using
Emacs.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup

iconv -f ISO-8859-1 -t UTF-8 ChangeLog.Skribe > ChangeLog.Skribe.tmp
rm ChangeLog.Skribe
mv ChangeLog.Skribe.tmp ChangeLog.Skribe
iconv -f ISO-8859-1 -t UTF-8 doc/man/skribilo.1.in > doc/man/skribilo.1.in.tmp
rm doc/man/skribilo.1.in
mv doc/man/skribilo.1.in.tmp doc/man/skribilo.1.in

%build
%configure --with-guilemoduledir=%{_datadir}/guile/site/%{mver}
%make_build

%install
%make_install
# Replace absolute links with relative links
rm %{buildroot}%{_infodir}/*.png
for i in %{buildroot}%{_docdir}/%{name}/*.png; do \
  (cd %{buildroot}%{_infodir}; \
   ln -sf -r "$i" . ); \
done
rm %{buildroot}/%{_docdir}/%{name}/*.pdf
# Symlink fonts
# Junction fonts
# https://packages.fedoraproject.org/pkgs/lomt-junction-fonts/lomt-junction-fonts
rm -f %{buildroot}%{_docdir}/%{name}/junction.ttf
ln -sf /usr/share/fonts/Junction-regular.otf  %{buildroot}%{_docdir}/%{name}/Junction-regular.otf
# lobster fonts have been orphaned
# https://src.fedoraproject.org/rpms/impallari-lobster-fonts
# Though bundled with TexLive
# https://packages.fedoraproject.org/pkgs/texlive/texlive-lobster2/
rm -f %{buildroot}%{_docdir}/%{name}/lobster-1.4.otf
ln -sf /usr/share/fonts/lobster2/LobsterTwo-Regular.otf %{buildroot}%{_docdir}/%{name}/LobsterTwo-Regular.otf
# Hack-Regular
# https://src.fedoraproject.org/rpms/source-foundry-hack-fonts
rm -f %{buildroot}%{_docdir}/%{name}/static/Hack-Regular.ttf
ln -sf /usr/share/fonts/source-foundry-hack-fonts/Hack-Regular.ttf %{buildroot}%{_docdir}/%{name}/static/Hack-Regular.ttf
# LinBiolinum_Rah
# https://packages.fedoraproject.org/pkgs/linux-libertine-fonts/linux-libertine-biolinum-fonts
rm -f %{buildroot}%{_docdir}/%{name}/static/LinBiolinum_Rah.ttf
ln -sf /usr/share/fonts/linux-libertine/LinBiolinum_R.otf %{buildroot}%{_docdir}/%{name}/static/LinBiolinum_R.otf
# LinLibertine_Rah
# https://packages.fedoraproject.org/pkgs/linux-libertine-fonts/linux-libertine-fonts/
rm -f %{buildroot}%{_docdir}/%{name}/static/LinLibertine_Rah.ttf
ln -sf /usr/share/fonts/linux-libertine/LinLibertine_R.otf %{buildroot}%{_docdir}/%{name}/static/LinLibertine_R.otf
%find_lang %{name}

%check  
make check


%files -f %{name}.lang
%license COPYING
%doc README
%doc README.Skribe
%doc NEWS
%doc ChangeLog.Skribe
%doc THANKS
%doc AUTHORS
%{_bindir}/%{name}
%{_bindir}/%{name}-config
%{_datadir}/guile/site/%{mver}/diff.scm
%{_datadir}/guile/site/%{mver}/%{name}.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}
 %{_datadir}/guile/site/%{mver}/%{name}/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/biblio
%{_datadir}/guile/site/%{mver}/%{name}/biblio/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/package
%{_datadir}/guile/site/%{mver}/%{name}/package/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/package/slide
%{_datadir}/guile/site/%{mver}/%{name}/package/slide/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/documentation
%{_datadir}/guile/site/%{mver}/%{name}/documentation/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/package/eq
%{_datadir}/guile/site/%{mver}/%{name}/package/eq/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/engine
%{_datadir}/guile/site/%{mver}/%{name}/engine/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/package/pie
%{_datadir}/guile/site/%{mver}/%{name}/package/pie/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/utils
%{_datadir}/guile/site/%{mver}/%{name}/utils/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/reader
%{_datadir}/guile/site/%{mver}/%{name}/reader/*.scm
%dir %{_datadir}/guile/site/%{mver}/%{name}/source
%{_datadir}/guile/site/%{mver}/%{name}/source/*.scm
%dir %{_docdir}/%{name}/static
%{_docdir}/%{name}/static/*.css
%{_docdir}/%{name}/static/*.png
%{_docdir}/%{name}/*.png
%{_docdir}/%{name}/*.html
%{_docdir}/%{name}/*.sui
# soft linked fonts
%{_docdir}/%{name}/Junction-regular.otf
%{_docdir}/%{name}/LobsterTwo-Regular.otf
%{_docdir}/%{name}/static/Hack-Regular.ttf
%{_docdir}/%{name}/static/LinBiolinum_R.otf
%{_docdir}/%{name}/static/LinLibertine_R.otf
%{_mandir}/man1/%{name}.1.gz
%{_libdir}/guile/%{mver}/site-ccache/diff.go
%{_libdir}/guile/%{mver}/site-ccache/%{name}.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}
%{_libdir}/guile/%{mver}/site-ccache/%{name}/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/biblio
%{_libdir}/guile/%{mver}/site-ccache/%{name}/biblio/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/documentation
%{_libdir}/guile/%{mver}/site-ccache/%{name}/documentation/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/engine
%{_libdir}/guile/%{mver}/site-ccache/%{name}/engine/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/package
%{_libdir}/guile/%{mver}/site-ccache/%{name}/package/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/package/eq
%{_libdir}/guile/%{mver}/site-ccache/%{name}/package/eq/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/package/pie
%{_libdir}/guile/%{mver}/site-ccache/%{name}/package/pie/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/package/slide
%{_libdir}/guile/%{mver}/site-ccache/%{name}/package/slide/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/reader
%{_libdir}/guile/%{mver}/site-ccache/%{name}/reader/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/source
%{_libdir}/guile/%{mver}/site-ccache/%{name}/source/*.go
%dir %{_libdir}/guile/%{mver}/site-ccache/%{name}/utils
%{_libdir}/guile/%{mver}/site-ccache/%{name}/utils/*.go
%{_infodir}/*.png.gz
%{_infodir}/%{name}.info.gz

%files emacs
%{_datadir}/emacs/site-lisp/skribe.el

%changelog
* Wed Jun 28 2023 Benson Muite <benson_muite@emailplus.org> - 0.9.5-1
- Initial packaging
